import Toybox.Application;
import Toybox.Lang;
import Toybox.WatchUi;
import Toybox.Graphics;

class DemoViewLoopIssueApp extends Application.AppBase {

    function initialize() {
        AppBase.initialize();
    }

    // onStart() is called on application start up
    function onStart(state as Dictionary?) as Void {
    }

    // onStop() is called when your application is exiting
    function onStop(state as Dictionary?) as Void {
    }

    // Return the initial view of your application here
    function getInitialView() as [Views] or [Views, InputDelegates] {
        var myViewLoop = new ViewLoop(new MyViewLoopFactory(), null);
        return [ myViewLoop, new ViewLoopDelegate(myViewLoop) ];
    }

}

function getApp() as DemoViewLoopIssueApp {
    return Application.getApp() as DemoViewLoopIssueApp;
}

class MyViewLoopFactory extends ViewLoopFactory {
    private var _views as Array<View> = [
        new MySimpleView("View 1"),
        new MySimpleView("View 2"),
        new MySimpleView("View 3"),
        new MySimpleView("View 4"),
        new MySimpleView("View 5")
    ];

    function initialize() {
        ViewLoopFactory.initialize();
    }

    public function getSize() {
        return _views.size();
    }

    public function getView(index as Number) {
        return [ _views[index], new BehaviorDelegate() ];
    }
}

class MySimpleView extends View {
    private var _message as String?;
    
    function initialize(message as String) {
        View.initialize();
        _message = message;
    }

    /*
    function onLayout(dc as Dc) {
    }
    */
    
    function onShow() {
    }

    function onUpdate(dc as Dc) {
        View.onUpdate(dc);

        dc.setColor(Graphics.COLOR_WHITE, Graphics.COLOR_TRANSPARENT);
        dc.drawText(100, 100, Graphics.FONT_MEDIUM, _message, Graphics.TEXT_JUSTIFY_RIGHT);
    }

    function onHide() {
    }

}